//+------------------------------------------------------------------+
//|                                                   Separation.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2010, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Green
#property indicator_levelcolor Red
#property indicator_levelstyle STYLE_SOLID
#property indicator_level1 8
#property indicator_level2 -8
#property indicator_minimum -20
#property indicator_maximum 20
extern bool Alerts_On = true;

//---- buffers
double IND[];
bool EntryFlag,TradeFlag;
datetime CurrBar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("Separation");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,IND);
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
     int limit;
     int counted_bars=IndicatorCounted();
     if(counted_bars<0) return(-1);
     if(counted_bars>0) counted_bars-=10;
     limit=Bars-counted_bars;

     int Price=0;
     int Mode=1;
     int ShortPeriod=12;
     int LongPeriod=26;
         
     for(int i=0; i<limit; i++)
       {
        IND[i]=(iMA(NULL,0,ShortPeriod,0,Mode,Price,i)-iMA(NULL,0,LongPeriod,0,Mode,Price,i)) / Point;
        
        if (Time[0] != CurrBar) {
         bool NewBar = true;
         CurrBar = Time[0]; }
        else NewBar = false;
        
        if (NewBar)
        { 
        if (MathAbs(IND[0]) > 8 && EntryFlag)
         TradeFlag = true;
        else if (MathAbs(IND[0]) < 8) 
         EntryFlag = true;
        
        if (Alerts_On && EntryFlag && TradeFlag && NewBar) {
         Alert("Separation - Potential Trade Signal (M",Period()," ",Symbol(),")"); 
         TradeFlag = false;
         EntryFlag = false; }
        }
       
       }
  //----
    return(0);
  }
//+------------------------------------------------------------------+